;;;;;;;;;;******************************************************************************************
FUNCTION READ_ABI_NETCDF_01, inputfiles,vars, outputfile, dprint=dprint, xx=xx, yy=yy, nvars=nvars, lineele=lineele
	if not keyword_set(dprint ) then dprint = 0
	if not keyword_set( outputfile ) then outputfile=''
		

;;	west_east=2654 & south_north=1222 
         zz=N_ELEMENTS(inputfiles)  
;;	IF (katr EQ 1) THEN BEGIN
;;		west_east=753 
;;		south_north=685
;;	ENDIF

;;vars= the variable index to read.
;;nvars=the number of variables to create.

dname1='x' & dname2='y'
  
if not keyword_set( xx ) then dname1='x'  ;'west_east' 
if not keyword_set( yy ) then dname2='y'  ;'south_north'

	IF (inputfiles(0) NE '')THEN BEGIN
		
		ncdfid= NCDF_OPEN(inputfiles(0))
   		fileinfo= NCDF_INQUIRE(ncdfid)
                 
    WE = NCDF_DIMID( ncdfid, dname1) 
		SE = NCDF_DIMID( ncdfid, dname2)
		
		NCDF_DIMINQ, ncdfid, WE, Name1, Size1 
		NCDF_DIMINQ, ncdfid, SE, Name2, Size2

		ngatts=fileinfo.ngatts
    nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		
		gatts={name:'',value:''}
		gats=REPLICATE(gatts,ngatts)

    rep=1
    IF (lineele EQ 1) THEN BEGIN
        rep=2 & size2=1
    ENDIF
		varnames=STRARR(nvars)
		avarset={data:FLTARR(Size1, Size2),var:'', attr:STRARR(8), attrval:STRARR(8),nvars:nvars, nvarsatt:0, ngatts:ngatts}
		dataset=REPLICATE(avarset,rep) ;  nvars)
    
    
    outdata= {gats:gats,dataset:dataset}
	  ;newoutdata=outdata ;REPLICATE(outdata, zz) ;nvars)

		NCDF_CLOSE, ncdfid
	;;ENDIF
	
	FOR ww=0, zz-1 DO BEGIN
	
		ncdfid= NCDF_OPEN(inputfiles(0))
   	fileinfo= NCDF_INQUIRE(ncdfid)

		ngatts=fileinfo.ngatts
    ;nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		


		 FOR i=0L, ngatts -1L DO BEGIN
			gattrnames[i]= NCDF_ATTNAME(ncdfid,i, /global)
				       NCDF_ATTGET,ncdfid, gattrnames[i], gattvalue, /global
				       gats(i).name=gattrnames[i]
				       gats(i).value=string(gattvalue)
				       IF (dprint EQ 1) THEN printf, 1, gats(i)
					;print, 'gats' ,gats(i)
		 ENDFOR
		
		
    IF (lineele EQ 0) THEN BEGIN          
		  FOR j=vars, vars DO BEGIN 
		      varinfo=NCDF_VARINQ(ncdfid,j)
		      dataset(0).var=varinfo.name  
            print, dataset(0).var
		         varid=NCDF_VARID(ncdfid, varinfo.name)
 		         NCDF_VARGET,ncdfid, varid, temp_data
		         dataset(0).data = temp_data
             kkk= where (temp_data GE -997) & lll=SIZE(KKK)
		      IF (dprint EQ 1) THEN printf,1 ,dataset(0).data
		      natts=varinfo.natts
		      dataset.nvarsatt=natts
				FOR k=0L, natts- 1L DO BEGIN
					dataset(0).attr(k)=NCDF_ATTNAME(ncdfid,varid, k) 
					NCDF_ATTGET, ncdfid, varid, dataset(0).attr(k), attvalue
					IF ((j LE 1) AND  (k EQ 2) AND nvars  GE 3) THEN BEGIN
              dataset(0).attrval(k)= string(attvalue(0))
           ENDIF ELSE BEGIN
           dataset(0).attrval(k)= string(attvalue)    ;;crashes when reading "-90, 90" or "-180 180"
					ENDELSE
				ENDFOR	
				outdata.gats=gats			
 				outdata.dataset(0)= dataset(0)
		ENDFOR
	ENDIF ELSE BEGIN   
	     aa=1  ;2  
	     bb=0      
      FOR j=aa, nvars-3 DO BEGIN 
          varinfo=NCDF_VARINQ(ncdfid,j)
          dataset(bb).var=varinfo.name  
           print, dataset(bb).var
             varid=NCDF_VARID(ncdfid, varinfo.name)
             NCDF_VARGET,ncdfid, varid, temp_data
             dataset(bb).data = temp_data
             kkk= where (temp_data GE -997) & lll=SIZE(KKK)
          IF (dprint EQ 1) THEN printf,1 ,dataset(bb).data
          natts=varinfo.natts
          dataset.nvarsatt=natts
        FOR k=0L, natts- 1L DO BEGIN
          dataset(bb).attr(k)=NCDF_ATTNAME(ncdfid,varid, k) 
          NCDF_ATTGET, ncdfid, varid, dataset(bb).attr(k), attvalue
          IF ((bb LE 1) AND  (k EQ 2) AND nvars  GE 3) THEN BEGIN
              dataset(bb).attrval(k)= string(attvalue(0))
           ENDIF ELSE BEGIN
           dataset(bb).attrval(k)= string(attvalue)    ;;crashes when reading "-90, 90" or "-180 180"
          ENDELSE
        ENDFOR  
        outdata.gats=gats      
        outdata.dataset(bb)= dataset(bb)
        j=j+1 & bb=bb+1
    ENDFOR
  ENDELSE
  		
  		
		NCDF_CLOSE, ncdfid
		CLOSE, /ALL
	ENDFOR
	
 ENDIF ELSE BEGIN
    outdata=''
 ENDELSE
 

 ;;;;  CALL THE SUBSET ROUTIE TO SUBSET THE LINE ELEMENTS FILE
 ;;;; TO MATCH THE DATA DOMAIN
      IF (lineele EQ 1) THEN BEGIN
         startx=3540/2 & starty=9350/2 & xrange=1160/2 & yrange=656/2
         newoutdata=SUBSETDATA(outdata, startx, starty, xrange, yrange)
          outdata=newoutdata
      ENDIF
      
   
RETURN, outdata ;subdata

END
;;;;***********************************************************************************************





FUNCTION SUBSETDATA, data, startx, starty, xrange, yrange

  stopx=startx+xrange & stopy=starty+ yrange
   ; uu=SIZE(data.dataset(0).data)
   ; tdata={gats:'',data:FLTARR(uu[1])}
   ; adata=REPLICATE(tdata,2)
   ; sub_data={dataset:adata}
     
   lines=data.dataset(0).data(startx:stopx-1)  ;;; xx
   elements=data.dataset(1).data(starty:stopy-1)   ;;yy   sub_data.dataset(1).data
   
   
   ;;;;;;;;;;;;;;;;;;;;;;
    print, 'min(lines), max(lines)'
    print, min(lines), max(lines)
    print, 'min(elements), max(elements)'
    print, min(elements), max(elements)
   
  sub_data={lines:lines, elements:elements}
  
  
  print, 'done subsetting'
  

return, sub_data
END















